
;;; -*- Mode: Lisp; Package: User; Base: 8.; Patch-File: T -*-
;;; Written 10/17/86 12:26:15 by SPERRY,
;;; Reason: Added definitions for :send-long-break and :send-short-break methods
;;; to serial-stream-mixin, and defined the analagous commands for the
;;; VT100 emulator.
;;; while running on A from band LOD1
;;; with System  2.11, Compiler  2.0, File System  2.0, Universal Command Loop  2.0, Window System  2.1, Input Editor  2.0, ZMACS  2.3, Error Handler  2.0, Suggestions  2.0, Debug Utilities  2.2, Explorer-Net  2.5, Telnet  2.0, Vt100  2.0, File Server  2.0, Net-Config  2.1, Font Editor  2.0, Mailer  2.1, Mail-Reader  2.2, Streamer-Tape  2.3, Local-File  2.10, System-Log  2.0, Serial-Parallel  2.0, Printer  2.0, Glossary  2.0, IMAGEN  2.0, NVRAM  2.0, User Profile Utility  2.1, SPERRY  2.0, KEE2  1.6401, Graphics-Window  2.0, Graphics-Editor  2.0, Tree-Drawing-Utility  2.0, RTMS  2.5, NLMenu  2.0, NLMenu-RTMS-Interface  2.0, PROLOG  2.1, Grasper  2.0, Formatter  2.0, Color Graphics  1.0, IP  1.5, KERMIT  1.0, microcode 258, Rel 2.0.1 + KEE + 8 kits, 7-1-86.



#!Z
; From file SERIAL-TELNET.LISP#> KERMIT; A:
#8R TELNET#:
(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "TELNET"))
                         (SI:LISP-MODE :ZETALISP)
                         (*READTABLE* SI:STANDARD-READTABLE)
                         (SI:*READER-SYMBOL-SUBSTITUTIONS* NIL))
  (COMPILER#:PATCH-SOURCE-FILE "LM: KERMIT; SERIAL-TELNET.#"

si:
(defmethod (serial-stream-mixin :SEND-LONG-BREAK) ()
 "Transmits a space condition for 3.5 seconds (long break)."
  (write-z-reg 5
	       (logand #x7F            ; Turn off DTR
		       (logior #x+10 WR5-CONTENTS)))  ;turn on send break
  (sleep 3.5 "Sending Long Break")
  (write-z-reg 5 WR5-CONTENTS)         ;restore register
  )
))


#!Z
; From file SERIAL-TELNET.LISP#> KERMIT; A:
#8R TELNET#:
(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "TELNET"))
                         (SI:LISP-MODE :ZETALISP)
                         (*READTABLE* SI:STANDARD-READTABLE)
                         (SI:*READER-SYMBOL-SUBSTITUTIONS* NIL))
  (COMPILER#:PATCH-SOURCE-FILE "LM: KERMIT; SERIAL-TELNET.#"

si:
(defmethod (serial-stream-mixin :SEND-SHORT-BREAK) ()
 "Transmits a space condition for .275 seconds (short break)."
  (write-z-reg 5 (logior #x+10 WR5-CONTENTS))  ;turn on send break
  (sleep .275 "Sending Short Break")
  (write-z-reg 5 WR5-CONTENTS)                 ;restore register
  )
))

#!Z
; From file SERIAL-TELNET.LISP#> KERMIT; A:
#8R TELNET#:
(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "TELNET"))
                         (SI:LISP-MODE :ZETALISP)
                         (*READTABLE* SI:STANDARD-READTABLE)
                         (SI:*READER-SYMBOL-SUBSTITUTIONS* NIL))
  (COMPILER#:PATCH-SOURCE-FILE "LM: KERMIT; SERIAL-TELNET.#"



(DEFCOMMAND (VT100-FRAME :LONG-BREAK) ()
  '(:DESCRIPTION "Send a short break to stream."
    :NAMES ("Long Break")
    :KEYS ((#\NETWORK #\CTRL-BREAK)))
  (if (not (null connection))
      (send stream :send-long-break)
      (format t "~&Not connected. Can't send Long Break.")
      (when (not ucl:preempting?)
	(send self :handle-prompt))))

))

#!Z
; From file SERIAL-TELNET.LISP#> KERMIT; A:
#8R TELNET#:
(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "TELNET"))
                         (SI:LISP-MODE :ZETALISP)
                         (*READTABLE* SI:STANDARD-READTABLE)
                         (SI:*READER-SYMBOL-SUBSTITUTIONS* NIL))
  (COMPILER#:PATCH-SOURCE-FILE "LM: KERMIT; SERIAL-TELNET.#"



(DEFCOMMAND (VT100-FRAME :SHORT-BREAK) ()
  '(:DESCRIPTION "Send a short break to stream."
    :NAMES ("Short Break")
    :KEYS ((#\NETWORK #\BREAK)))
  (if (not (null connection))
      (send stream :send-short-break)
      (format t "~&Not connected. Can't send Short Break.")
      (when (not ucl:preempting?)
	(send self :handle-prompt))))
))

#!Z
; From file SERIAL-TELNET.LISP#> KERMIT; A:
#8R TELNET#:
(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "TELNET"))
                         (SI:LISP-MODE :ZETALISP)
                         (*READTABLE* SI:STANDARD-READTABLE)
                         (SI:*READER-SYMBOL-SUBSTITUTIONS* NIL))
  (COMPILER#:PATCH-SOURCE-FILE "LM: KERMIT; SERIAL-TELNET.#"



(BUILD-COMMAND-TABLE 'VT100-TELNET-CMD-TABLE 'VT100-FRAME
  '((:method telnet-frame :exit-command)		
    (:method telnet-frame :disconnect-command)
    (:method telnet-frame :interrupt-process-command)
    :send-answerback-command
    :reverse-video-command
    :reset-command
    :escape-processing-command
    (:method telnet-frame :quit-and-disconnect-command)
    (:method telnet-frame :status-command)
    (:method telnet-frame :abort-output-command)
    :column-command
    :truncate-command
    :set-vt100-lines
    :network-help-command
    (:method telnet-frame :clear-input-command)
    (:method vt100-frame :autodial)                   ; BAC
    (:method vt100-frame :kermit)                     ; BAC
    :local-echo-command                               ; BAC
    :short-break
    :long-break
    )
  :INIT-OPTIONS
  '(:NAME "Vt100 & Telnet Commands"
	  :DOCUMENTATION "The Vt100 & Telnet commands."))

))

#!Z
; From file SERIAL-TELNET.LISP#> KERMIT; A:
#8R TELNET#:
(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "TELNET"))
                         (SI:LISP-MODE :ZETALISP)
                         (*READTABLE* SI:STANDARD-READTABLE)
                         (SI:*READER-SYMBOL-SUBSTITUTIONS* NIL))
  (COMPILER#:PATCH-SOURCE-FILE "LM: KERMIT; SERIAL-TELNET.#"



(BUILD-MENU 'UCL-VT100-TELNET-MENU 'VT100-FRAME
  :DEFAULT-ITEM-OPTIONS
  '(:FONT FONTS:MEDFNT)
  :ITEM-LIST-ORDER
    '( ;Row 1
      (:method telnet-frame :exit-command)		
      (:method telnet-frame :disconnect-command)
      (:method telnet-frame :interrupt-process-command)
      :send-answerback-command
      :reverse-video-command
      :reset-command
      :escape-processing-command
       ;Row 2
      (:method telnet-frame :quit-and-disconnect-command)
      (:method telnet-frame :status-command)
      (:method telnet-frame :abort-output-command)
      :column-command
      :truncate-command
      :set-vt100-lines
      :network-help-command
       ;Row 3                                           ; BAC
      (:method vt100-frame :autodial)                   ; BAC
      (:method vt100-frame :kermit)                     ; BAC
      :local-echo-command                               ; BAC
      :short-break
      :long-break
      ))

))

