
;;; -*- Mode: Lisp; Package: User; Base: 8.; Patch-File: T -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1986, Texas Instruments Incorporated.  All rights reserved.

;;; Written 5/16/86 17:44:10 by FORD,
;;; Reason: Change :CLOSE to clear the hardware registers.
;;; while running on B from band LOD2
;;; with System 2.44, Compiler 2.5, File System 2.1, Universal Command Loop 2.0, Window System 2.5, Input Editor 2.0, ZMACS 2.5, Error Handler 2.0, Suggestions 2.1, Debug Utilities 2.7, Explorer-Net 2.6, Telnet 2.2, Vt100 2.0, File Server 2.0, Net-Config 2.2, Font Editor 2.2, Mailer 2.4, Mail-Reader 2.4, Streamer-Tape 2.7, Local-File 2.15, System-Log 2.2, Serial-Parallel 2.8, Printer 2.0, Glossary 2.0, IMAGEN 2.1, NVRAM 2.3, User Profile Utility 2.1, IP 1.15, Experimental Code Management Interface 2.22, Experimental Explorer Bug System 20.0, microcode 287, FAN23-MCR287-AUS.



#!Z
; From file SERIAL-STREAM.LISP#> SERIAL; A:
#8R SYSTEM-INTERNALS#:
(COMPILER-LET ((PACKAGE (PKG-FIND-PACKAGE "SYSTEM-INTERNALS"))
                         (SI:LISP-MODE :ZETALISP)
                         (*READTABLE* STANDARD-READTABLE)
                         (SI:*READER-SYMBOL-SUBSTITUTIONS* NIL))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: SERIAL; SERIAL-STREAM.#"


(Defmethod (Serial-Stream-Mixin :CLOSE) (&Optional Abort-P)
  ;; deallocate the serial buffers
  (IF *serial-output-buffer*
      (PROGN
        (IF (NOT abort-p) (FUNCALL-SELF ':finish))
        (return-serial-buffer *serial-Output-Buffer*)
        (SETQ *Serial-Output-Buffer* nil)))
  (IF *Serial-Input-Buffer*
      (PROGN
        (return-serial-buffer *Serial-Input-Buffer*)
        (SETQ *Serial-Input-Buffer* nil)))
  (array-dpb-offset 0 %%q-pointer *serial-port* %serial-receive-buffer)
  (array-dpb-offset 0 %%q-pointer *serial-port* %serial-transmit-buffer)
  (setq *serial-port-owner* nil)
  (write-z-reg 9   0)  ;clear master interrupt control register
  (write-z-reg 5   0)  ;DTR, RTS, Tx disable
  (write-z-reg 3   0)  ;Rx disable
  (write-z-reg 15. 0)  ;disable external interrupts
  (write-z-reg 1   0)  ;disable interrupts
  (disable-serial-event)              ;disable SIB serial event posting
  )
))

